/*
 * Copyright (C) 2014 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <sys/stat.h>
#include <sys/types.h>
#include <assert.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "libtp.h"

int main(int argc, char *argv[])
{
	int err, fd[2], do_close;
	char pat[16], *fname, *method, *p, a[8];
	struct lock_ops *ops;

	fname = argv[1];
	method = argv[2];
	ops = lock_ops(method);
	p = argv[3];
	if (!strcmp(p, "unlock"))
		do_close = 0;
	else if (!strcmp(p, "close"))
		do_close = 1;
	else
		assert(0);

	fd[0] = open_and_pat(fname, O_RDWR, pat, sizeof(pat));
	assert(fd[0] >= 0);
	printf("got fd %d\n", fd[0]);
	fd[1] = dup(fd[0]);
	assert(fd[1] >= 0);
	printf("got fd %d\n", fd[1]);

	snprintf(a, sizeof(a), "fd %d", fd[0]);
	err = ops->lock(fd[0], a);
	assert(!err);
	GREP_LOCK(pat);

	snprintf(a, sizeof(a), "fd %d", fd[1]);
	if (do_close) {
		printf("%s closes\n", a);
		err = close(fd[1]);
	} else
		err = ops->unlock(fd[1], a);
	assert(!err);
	GREP_LOCK(pat);

	return 0;
}
