/*
 * Copyright (C) 2014 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/* linux/include/uapi/asm-generic/fcntl.h */
#ifndef  F_OFD_GETLK
#define F_OFD_GETLK	36
#define F_OFD_SETLK	37
#define F_OFD_SETLKW	38
#endif

struct lock_ops {
	int (*lock)(int fd, char *prefix);
	int (*unlock)(int fd, char *prefix);
};

/* libtp.c */
struct lock_ops *lock_ops(char *str);
int open_and_pat(char *fname, int flags, char pat[], int n);
void grep_lock(char pat[], const char func[], int line);

#define GREP_LOCK(pat) 	grep_lock(pat, __func__, __LINE__)
