#!/bin/sh

set -eu
test $(uname -s) = Linux
rev=$(uname -r)
major=$(echo $rev | cut -f1 -d.)
test $major -eq 3
minor=$(echo $rev | cut -f2 -d.)
locks="flock posix"
test $minor -ge 15 &&
locks="$locks ofd"

dir=$(dirname $0)
testfile=/tmp/testfile
test -e $testfile || > $testfile
echo $testfile is $(stat -c '(dev %04D, inum %i)' $testfile)

set -x
for i
do
	case $i in
	setlk-ofd)
		test $minor -ge 15 &&
		{
			$dir/$i $testfile posix ofd
			$dir/$i $testfile ofd posix
		}
		;;
	two-opens)
		for j in none unlock close
		do
			$dir/$i $testfile flock $j &
			sleep 1
			fgrep -Hw $! /proc/locks || :
			kill $! || :
			wait
			$dir/$i $testfile posix $j
			test $minor -ge 15 &&
			{
			$dir/$i $testfile ofd $j &
			sleep 1
			fgrep -Hw $! /proc/locks || :
			kill $! || :
			wait
			}
		done
		;;
	flock-dup|flock-fork|two-opens-mt)
		for j in $locks
		do
			for k in unlock close
			do
				$dir/$i $testfile $j $k
			done
		done
		;;
	*)
		for j in $locks
		do
			$dir/$i $testfile $j
		done
		;;
	esac
done
