/*
 * Copyright (C) 2014 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <sys/stat.h>
#include <sys/types.h>
#include <assert.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "libtp.h"

struct lock_ops *ops;
char pat[16];

static int lock_it(char *fname)
{
	int err, fd;
	char a[8];

	fd = open_and_pat(fname, O_RDWR, pat, sizeof(pat));
	assert(fd >= 0);

	snprintf(a, sizeof(a), "fd %d", fd);
	err = ops->lock(fd, a);
	assert(!err);

	return fd;
}

int main(int argc, char *argv[])
{
	int err, i, how_unlock, fd[2];
	char *p, *fname, *method, a[8];

	fname = argv[1];
	method = argv[2];
	ops = lock_ops(method);
	p = argv[3];
	if (!strcmp(p, "none"))
		how_unlock = 0;
	else if (!strcmp(p, "unlock"))
		how_unlock = 1;
	else if (!strcmp(p, "close"))
		how_unlock = 2;
	else
		assert(0);

	for (i = 0; i < 2; i++)
		fd[i] = lock_it(fname);
	GREP_LOCK(pat);

	if (how_unlock)
		for (i = 0; i < 2; i++) {
			snprintf(a, sizeof(a), "fd %d", fd[i]);
			switch (how_unlock) {
			case 1:
				err = ops->unlock(fd[i], a);
				break;
			case 2:
				printf("%s closes\n", a);
				err = close(fd[i]);
				break;
			}
			assert(!err);
			GREP_LOCK(pat);
		}

	return 0;
}
